<?php
/*
Plugin Name: Google Maps Quicktag
Plugin URI: http://www.remotesensingtools.com/2007/08/22/wordpress-plugin-google-maps-quicktag/
Description: Google Maps Quicktag makes it convenient to open the Google Maps web site while editing, where you can generate your map and copy the needed code to paste into the editor.
Version: 1.0.1
Author: Daniel Denk
Author URI: http://www.remotesensingtools.com/
*/

// SCRIPT INFO
/*
	Google Maps Quicktag for WordPress
	(c)2007 Daniel Denk - GNU General Public License

	This Wordpress plugin is released under a GNU General Public License.
	A complete version of this license can be found here:
	http://www.gnu.org/licenses/gpl.txt

	This WordPress plugin has been tested with WordPress 2.0.x, 2.2.x, 2.3.x, 2.5.x, 2.6.x

	This WordPress plugin is released "as is", without any warranty. The author
	cannot be held responsible for any damage that this script might cause.
*/


// TinyMCE

add_filter('mce_valid_elements', 'mymaps_mce_valid_elements', 0);

function mymaps_mce_valid_elements($valid_elements) {
  $valid_elements .= 'mymaps[width|height]';
  return $valid_elements;
}


// Add javascript to generate a quicktag button.
function mymaps_button() {
  // Add javascript to the following pages
  if (strpos($_SERVER['REQUEST_URI'], 'post.php') ||
      strpos($_SERVER['REQUEST_URI'], 'post-new.php') ||
	  strpos($_SERVER['REQUEST_URI'], 'page.php') ||
      strpos($_SERVER['REQUEST_URI'], 'page-new.php') ||
      strpos($_SERVER['REQUEST_URI'], 'bookmarklet.php')) {

    // Print out HTML/Javascript to add the button
?>

<div id="mymaps_link" style="margin-bottom:10px; display:none;">
<a href="#" onclick="return mymaps_open('tinymce=true')">Open Google Maps</a>
</div>

<script type="text/javascript">
//<![CDATA[
var mymaps_toolbar = document.getElementById("ed_toolbar");

if (mymaps_toolbar) {
  var theButton = document.createElement('input');
  theButton.type = 'button';
  theButton.value = 'Open Google Maps';
  theButton.onclick = mymaps_button;
  theButton.className = 'ed_button';
  theButton.title = 'Open Google Maps';
  theButton.id = 'ed_Mymaps';
  mymaps_toolbar.appendChild(theButton);
}
else {
  var mymapsLink = document.getElementById("mymaps_link");
  var pingBack = document.getElementById("pingback");
  if (pingBack == null)
    var pingBack = document.getElementById("post_pingback");
  if (pingBack == null) {
    var pingBack = document.getElementById("savepage");
    pingBack = pingBack.parentNode;
  }
  pingBack.parentNode.insertBefore(mymapsLink, pingBack);
  mymapsLink.style.display = 'block';
}

function mymaps_button(querystr) {
  // Change the URL to the actual page you wish to open if necessary
  // Optionally you can add width=x, height=x, to the variables to
  // open the window to an exact size
  myRef = window.open('http://maps.google.com/','mymaps','toolbar=yes,location=yes,scrollbars=yes,resizable=yes');
  myRef.focus();
  return false;
}

//]]>
</script>
<?php
    }
}

// Add the javascript to Admin pages
add_filter('admin_footer', 'mymaps_button');

?>